Customize Ribbon in JavaScript (ES5) Document Editor

1 Jul 20269 minutes to read

The Syncfusion JavaScript DOCX Editor (Document Editor) provides an extensive and flexible API to customize the built-in ribbon UI. You can:

  • Customize the File menu.
  • Add the Backstage menu instead of File menu.
  • Show, hide, or add Ribbon tabs.
  • Show, hide, or add groups within tabs.
  • Show, hide, add, enable, or disable items within groups.

Below are detailed examples for each ribbon customization scenario.

File Menu Customization

Document Editor provides APIs to remove existing File menu items and add new custom items based on your requirements. You can modify the File menu using the fileMenuItems property.

In below code example, In the example below, the “Open” and “Export” items have been removed from the File Menu Items, and new custom items have been added.

var documenteditorContainer = new ej.documenteditor.DocumentEditorContainer({ enabvaroolbar: true, 
toolbarMode: 'Ribbon', // Options: 'Ribbon' or 'Toolbar'
ribbonLayout: 'Classic', // Options: 'Simplified' or 'Classic',
fileMenuItems: ["New", "Print", { text: 'Export', id: 'custom_item',iconCss: 'e-icons e-export' }
],
fileMenuItemClick: function (args) {
    if (args.item.id) {
        container.documentEditor.save('Sample', 'Docx');
    }
},
height: '590px' });
ej.documenteditor.DocumentEditorContainer.Inject(ej.documenteditor.Ribbon);
documenteditorContainer.serviceUrl = 'https://document.syncfusion.com/web-services/docx-editor/api/documenteditor/';
//DocumentEditorContainer control rendering starts
documenteditorContainer.appendTo('#DocumentEditor');

Backstage Menu Customization

The Document Editor provides an backStageMenu API to add a backstage menu. When the backstage menu is enabled, the default File menu items are automatically hidden.

The following code example shows how to add the backstage menu items.

var documenteditorContainer = new ej.documenteditor.DocumentEditorContainer({ enabvaroolbar: true, 
toolbarMode: 'Ribbon', // Options: 'Ribbon' or 'Toolbar'
ribbonLayout: 'Classic', // Options: 'Simplified' or 'Classic',
backstageMenu: {
    text: 'File',
    backButton: { text: 'close' },
    items: [
    { id: 'new', text: 'New', iconCss: 'e-icons e-de-ctnr-new' }],
},
height: '590px' });
ej.documenteditor.DocumentEditorContainer.Inject(ej.documenteditor.Ribbon);
documenteditorContainer.serviceUrl = 'https://document.syncfusion.com/web-services/docx-editor/api/documenteditor/';
//DocumentEditorContainer control rendering starts
documenteditorContainer.appendTo('#DocumentEditor');

Refer this documentation know more about backstage items

Tab Customization

You can customize the ribbon tabs in the Document Editor by showing, hiding, or adding tabs according to your application’s requirements.

Show/Hide Tab

Document editor provides the showTab API to show and hide the existing tab using existing RibbonTabType and tabId.

The following code example how to show/hide existing tab using existing tab type and tab id.

// To hide the Home tab using the built-in `RibbonTabType`
container.ribbon.showTab('Home', false);

// To hide a tab by its tab id (for example, a custom tab)
container.ribbon.showTab('custom_tab', false);

Add Tab

The Document Editor provides the addTab API, which allows you to insert a new custom tab either between existing tabs or at the end of the ribbon tabs.

// To add the tab at end of tab
var ribbonTab = {
    header: 'Custom Tab', id: 'custom_tab', groups: [{
        header: 'Custom Group', collections: [{
            items: [{
                type: 'Button',
                buttonSettings: {
                    content: 'New',
                    iconCss: 'e-icons e-de-ctnr-new',
                    clicked: function () {
                        container.documentEditor.openBlank();
                    }
                }
            }]
        }]
    }]
};
container.ribbon.addTab(ribbonTab);

// To add the tab before the Insert tab(exising tab)
container.ribbon.addTab(ribbonTab,'Insert');

Group Customization

You can also customize ribbon groups within a tab to better organize commands or add new functionalities as per your needs.

Show/Hide Group

Document Editor provides an showGroup API to show or hide existing groups within a ribbon tab.

The following code example show how to show/hide the group using group Id or RibbonGroupInfo.

// To hide the clipboard group using group index
container.ribbon.showGroup({tabId: 'Home', index: 1} , false);

// To show the clipboard group using group index
container.ribbon.showGroup({tabId: 'Home', index: 1} , true);

// To hide the group using id
container.ribbon.showGroup('custom_group', false);

Add Group

To extend the ribbon’s functionality, you can add custom groups to any tab. This allows you to organize related commands together within a tab.

// Add the new group at the end of the Home tab
var ribbonGroup =
{
    header: 'Custom Group', collections: [{
        items: [{
            type: 'Button',
            buttonSettings: {
                content: 'New',
                iconCss: 'e-icons e-de-ctnr-new',
                clicked: function () {
                    container.documentEditor.openBlank();
                }
            }
        }]
    }]
};
container.ribbon.addGroup('Home', ribbonGroup);

// Add the new group at the specified index of the Home tab (before the Clipboard group)

container.ribbon.addGroup('Home', ribbonGroup, 1);

Item Customization

You can customize individual items within ribbon groups. This includes showing, hiding, enabling, disabling, or adding new items to any group within a ribbon tab.

Show/Hide Item

Using showItems API in Document editor ribbon to enable/disable the existing item. Here, you can specify the item Id or [RibbonItemInfo].

The following code example show how to show/hide the item using item Id or RibbonItemInfo.

// To hide the Bold and Italic items using ribbon item information
container.ribbon.showItems({ tabId: 'Home', groupIndex: 2, itemIndexes: [5, 6] } , false);

// To show the Bold and Italic items using ribbon item information
container.ribbon.showItems({ tabId: 'Home', groupIndex: 2, itemIndexes: [5, 6] } , true);

// To hide the item using item id
container.ribbon.showItems('custom_item', false);

Enable/Disable Item

Using enableItems API in Document editor ribbon to enable/disable the existing item.

// To disable the underline using ribbon item info
container.ribbon.enableItems({ tabId: 'Home', groupIndex: 2, itemIndexes: [7] },false);

// To enable the underline using ribbon item info
container.ribbon.enableItems({ tabId: 'Home', groupIndex: 2, itemIndexes: [7] },true);

// To disable the item using id
container.ribbon.enableItems('custom_item', false);

Add Item

You can use the addItem API in the Document Editor ribbon to add a new item. Additionally, you can specify the target tab and group where the new item should be placed.

// To add the item at the end of the specified group (the item will be added at the end of the Undo group)
var ribbonItem = {
    type: 'Button',
    buttonSettings: {
        content: 'New',
        iconCss: 'e-icons e-de-ctnr-new',
        clicked: function () {
            container.documentEditor.openBlank();
        }
    }
};
container.ribbon.addItem({ tabId: 'Home', index: 0 }, ribbonItem);

// To add the item before the specified item index (the item will be added before the Redo item in the Undo group)

container.ribbon.addItem({ tabId: 'Home', index: 0 }, ribbonItem, 1);

Online Demo

Explore how to customize the ribbon in the JavaScript (ES5) Document Editor for working with Word documents in this live demo here.

Customize Ribbon in Vue Document Editor

22 Jun 202624 minutes to read

The Vue DOCX Editor (Document Editor) provides an extensive and flexible API to customize the built-in ribbon UI. You can:

  • Customize the File menu.
  • Add the Backstage menu instead of File menu.
  • Show, hide, or add Ribbon tabs.
  • Show, hide, or add groups within tabs.
  • Show, hide, add, enable, or disable items within groups.

Below are detailed examples for each ribbon customization scenario.

File Menu Customization

Document Editor provides APIs to remove existing File menu items and add new custom items based on your requirements. You can modify the File menu using the fileMenuItems property.

In below code example, In the example below, the “Open” and “Export” items have been removed from the File Menu Items, and new custom items have been added.

<template>
<div class="control-section">
    <ejs-documenteditorcontainer ref="doceditcontainer" :toolbarMode="'Ribbon'" 
    :serviceUrl="hostUrl" :enableToolbar='true' height='600px' :fileMenuItems="fileMenuItems"
    @fileMenuItemClick="fileMenuClick"></ejs-documenteditorcontainer>
</div>
</template>
<script setup>
import { DocumentEditorContainerComponent, Toolbar, Ribbon } from "@syncfusion/ej2-vue-documenteditor";
import { onMounted, ref } from 'vue';

const documenteditorcontainer = ref(null);
provide('DocumentEditorContainer', [Toolbar, Ribbon]);
const fileMenuItems = [
  'New',
  'Print',
  { text: 'Export', id: 'custom_item', iconCss: 'e-icons e-export' }
];
function fileMenuClick(args) {
  if (args.item && args.item.id === 'custom_item') {
    doceditcontainer.value.ej2Instances.documentEditor.save('Sample', 'Docx');
  }
}
onMounted(() => {
  const editorInstance = doceditcontainer.value?.ej2Instances?.documentEditor;
});
</script>
<template>
<div class="control-section">
    <ejs-documenteditorcontainer ref="doceditcontainer" :toolbarMode="'Ribbon'" 
    :serviceUrl="hostUrl" :enableToolbar='true' height='600px' :fileMenuItems="fileMenuItems"
    @fileMenuItemClick="fileMenuClick"></ejs-documenteditorcontainer>
</div>
</template>

<script>
import { DocumentEditorContainerComponent, Toolbar, Ribbon } from "@syncfusion/ej2-vue-documenteditor";
export default {
  components: {
    'ejs-documenteditorcontainer': DocumentEditorContainerComponent,
  },
  provide: {
    DocumentEditorContainer: [Toolbar, Ribbon]
  },
  data() {
    return {
      fileMenuItems: [
        'New',
        'Print',
        { text: 'Export', id: 'custom_item', iconCss: 'e-icons e-export' }
      ]
    };
  },
  methods: {
    fileMenuClick(args) {
      if (args.item) {
        this.$refs.doceditcontainer.ej2Instances.documentEditor.save('Sample', 'Docx');
      }
    }
  }
};

</script>

Backstage Menu Customization

The Document Editor provides an backStageMenu API to add a backstage menu. When the backstage menu is enabled, the default File menu items are automatically hidden.

The following code example shows how to add the backstage menu items.

<template>
<div class="control-section">
    <ejs-documenteditorcontainer ref="doceditcontainer" :toolbarMode="'Ribbon'" 
    :serviceUrl="hostUrl" :enableToolbar='true' height='600px' :fileMenuItems="fileMenuItems"
    @fileMenuItemClick="fileMenuClick"></ejs-documenteditorcontainer>
</div>
</template>
<script setup>
import { DocumentEditorContainerComponent, Toolbar, Ribbon } from "@syncfusion/ej2-vue-documenteditor";
import { onMounted, ref } from 'vue';

const documenteditorcontainer = ref(null);
provide('DocumentEditorContainer', [Toolbar, Ribbon]);
const backstageMenu = {
  text: 'File',
  backButton: { text: 'close' },
  items: [
    { id: 'new', text: 'New', iconCss: 'e-icons e-de-ctnr-new' }
  ]
};
function handleBackstageItemClick(args) {
  if (args.item) {
    doceditcontainer.value.ej2Instances.documentEditor.openBlank();
  }
}
onMounted(() => {
  const editorInstance = doceditcontainer.value?.ej2Instances?.documentEditor;
});
</script>
<template>
<div class="control-section">
    <ejs-documenteditorcontainer ref="doceditcontainer" :toolbarMode="'Ribbon'" 
    :serviceUrl="hostUrl" :enableToolbar='true' height='600px' :backstageMenu="backstageMenu"
    @backstageItemClick="handleBackstageItemClick"></ejs-documenteditorcontainer>
</div>
</template>

<script>
import { DocumentEditorContainerComponent, Toolbar, Ribbon } from "@syncfusion/ej2-vue-documenteditor";
export default {
  components: {
    'ejs-documenteditorcontainer': DocumentEditorContainerComponent,
  },
  provide: {
    DocumentEditorContainer: [Toolbar, Ribbon]
  },
  data() {
    return {
      backstageMenu: {
        text: 'File',
        backButton: { text: 'close' },
        items: [
          { id: 'new', text: 'New', iconCss: 'e-icons e-de-ctnr-new' }
        ]
      }
    };
  },
  methods: {
    handleBackstageItemClick(args) {
      if (args.item) {
        this.$refs.doceditcontainer.ej2Instances.documentEditor.openBlank();
      }
    }
  }
};
</script>

Refer this documentation know more about backstage items

Tab Customization

You can customize the ribbon tabs in the Document Editor by showing, hiding, or adding tabs according to your application’s requirements.

Show/Hide Tab

Document editor provides the showTab API to show and hide the existing tab using existing RibbonTabType and tabId.

The following code example how to show/hide existing tab using existing tab type and tab id.

// To hide the Home tab using the built-in `RibbonTabType`
this.$refs.doceditcontainer.ej2Instances.ribbon.showTab('Home', false);

// To hide a tab by its tab id (for example, a custom tab)
this.$refs.doceditcontainer.ej2Instances.ribbon.showTab('custom_tab', false);

Add Tab

The Document Editor provides the addTab API, which allows you to insert a new custom tab either between existing tabs or at the end of the ribbon tabs.

<template>
<div class="control-section">
    <ejs-documenteditorcontainer ref="doceditcontainer" :toolbarMode="'Ribbon'" 
    :serviceUrl="hostUrl" :enableToolbar='true' height='600px'></ejs-documenteditorcontainer>
</div>
</template>
<script setup>
import { DocumentEditorContainerComponent, Toolbar, Ribbon } from "@syncfusion/ej2-vue-documenteditor";
import { onMounted, ref } from 'vue';
import { RibbonTabModel } from '@syncfusion/ej2-ribbon';

const documenteditorcontainer = ref(null);
provide('DocumentEditorContainer', [Toolbar, Ribbon]);

onMounted(() => {
    const container = doceditcontainer.value?.ej2Instances;
    // To add the tab at end of tab
    const ribbonTab = {
      header: 'Custom Tab',
      id: 'custom_tab',
      groups: [{
        header: 'Custom Group',
        collections: [{
          items: [{
            type: 'Button',
            buttonSettings: {
              content: 'New',
              iconCss: 'e-icons e-de-ctnr-new',
              clicked: () => {
                container.documentEditor.openBlank();
              }
            }
          }]
        }]
      }]
    };
    container.ribbon.addTab(ribbonTab);

    // To add the tab before the Insert tab(exising tab)
    container.ribbon.addTab(ribbonTab, 'Insert');
});
</script>
<template>
<div class="control-section">
    <ejs-documenteditorcontainer ref="doceditcontainer" :toolbarMode="'Ribbon'" 
    :serviceUrl="hostUrl" :enableToolbar='true' height='600px'></ejs-documenteditorcontainer>
</div>
</template>

<script>
import { DocumentEditorContainerComponent, Toolbar, Ribbon } from "@syncfusion/ej2-vue-documenteditor";

export default {
  components: {
    'ejs-documenteditorcontainer': DocumentEditorContainerComponent,
  },
  provide: {
    DocumentEditorContainer: [Toolbar, Ribbon]
  },
  mounted() {
    const container = this.$refs.doceditcontainer.ej2Instances;

    // To add the tab at end of tab
    const ribbonTab = {
      header: 'Custom Tab',
      id: 'custom_tab',
      groups: [{
        header: 'Custom Group',
        collections: [{
          items: [{
            type: 'Button',
            buttonSettings: {
              content: 'New',
              iconCss: 'e-icons e-de-ctnr-new',
              clicked: () => {
                container.documentEditor.openBlank();
              }
            }
          }]
        }]
      }]
    };
    container.ribbon.addTab(ribbonTab);

    // To add the tab before the Insert tab(exising tab)
    container.ribbon.addTab(ribbonTab, 'Insert');
  }
};

</script>

Group Customization

You can also customize ribbon groups within a tab to better organize commands or add new functionalities as per your needs.

Show/Hide Group

Document Editor provides an showGroup API to show or hide existing groups within a ribbon tab.

The following code example show how to show/hide the group using group Id or RibbonGroupInfo.

// To hide the clipboard group using group index
this.$refs.doceditcontainer.ej2Instances.ribbon.showGroup({tabId: 'Home', index: 1} , false);

// To show the clipboard group using group index
this.$refs.doceditcontainer.ej2Instances.ribbon.showGroup({tabId: 'Home', index: 1} , true);

// To hide the group using id
this.$refs.doceditcontainer.ej2Instances.ribbon.showGroup('custom_group', false);

Add Group

To extend the ribbon’s functionality, you can add custom groups to any tab. This allows you to organize related commands together within a tab.

<template>
<div class="control-section">
    <ejs-documenteditorcontainer ref="doceditcontainer" :toolbarMode="'Ribbon'" 
    :serviceUrl="hostUrl" :enableToolbar='true' height='600px'></ejs-documenteditorcontainer>
</div>
</template>
<script setup>
import { DocumentEditorContainerComponent, Toolbar, Ribbon } from "@syncfusion/ej2-vue-documenteditor";
import { onMounted, ref } from 'vue';

const documenteditorcontainer = ref(null);
provide('DocumentEditorContainer', [Toolbar, Ribbon]);

onMounted(() => {
    const container = doceditcontainer.value?.ej2Instances;
    // Add the new group at the end of the Home tab
    const ribbonGroup = {
      header: 'Custom Group',
      collections: [
        {
          items: [
            {
              type: 'Button',
              buttonSettings: {
                content: 'New',
                iconCss: 'e-icons e-de-ctnr-new',
                clicked: () => {
                  container.documentEditor.openBlank();
                }
              }
            }
          ]
        }
      ]
    };
    container.ribbon.addGroup('Home', ribbonGroup);

    // Add the new group at the specified index of the Home tab (before the Clipboard group)

    container.ribbon.addGroup('Home', ribbonGroup, 1);
});
</script>
<template>
<div class="control-section">
    <ejs-documenteditorcontainer ref="doceditcontainer" :toolbarMode="'Ribbon'" 
    :serviceUrl="hostUrl" :enableToolbar='true' height='600px'></ejs-documenteditorcontainer>
</div>
</template>

<script>
import { DocumentEditorContainerComponent, Toolbar, Ribbon } from "@syncfusion/ej2-vue-documenteditor";

export default {
  components: {
    'ejs-documenteditorcontainer': DocumentEditorContainerComponent,
  },
  provide: {
    DocumentEditorContainer: [Toolbar, Ribbon]
  },
  mounted() {
    const container = this.$refs.doceditcontainer.ej2Instances;

    // Add the new group at the end of the Home tab
    const ribbonGroup = {
      header: 'Custom Group',
      collections: [
        {
          items: [
            {
              type: 'Button',
              buttonSettings: {
                content: 'New',
                iconCss: 'e-icons e-de-ctnr-new',
                clicked: () => {
                  container.documentEditor.openBlank();
                }
              }
            }
          ]
        }
      ]
    };
    container.ribbon.addGroup('Home', ribbonGroup);

    // Add the new group at the specified index of the Home tab (before the Clipboard group)

    container.ribbon.addGroup('Home', ribbonGroup, 1);
  }
};
</script>

Item Customization

You can customize individual items within ribbon groups. This includes showing, hiding, enabling, disabling, or adding new items to any group within a ribbon tab.

Show/Hide Item

Using showItems API in Document editor ribbon to enable/disable the existing item. Here, you can specify the item Id or [RibbonItemInfo].

The following code example show how to show/hide the item using item Id or RibbonItemInfo.

// To hide the Bold and Italic items using ribbon item information
this.$refs.doceditcontainer.ej2Instances.ribbon.showItems({ tabId: 'Home', groupIndex: 2, itemIndexes: [5, 6] } , false);

// To show the Bold and Italic items using ribbon item information
this.$refs.doceditcontainer.ej2Instances.ribbon.showItems({ tabId: 'Home', groupIndex: 2, itemIndexes: [5, 6] } , true);

// To hide the item using item id
this.$refs.doceditcontainer.ej2Instances.ribbon.showItems('custom_item', false);

Enable/Disable Item

Using enableItems API in Document editor ribbon to enable/disable the existing item.

// To disable the underline using ribbon item info
this.$refs.doceditcontainer.ej2Instances.ribbon.enableItems({ tabId: 'Home', groupIndex: 2, itemIndexes: [7] },false);

// To enable the underline using ribbon item info
this.$refs.doceditcontainer.ej2Instances.ribbon.enableItems({ tabId: 'Home', groupIndex: 2, itemIndexes: [7] },true);

// To disable the item using id
this.$refs.doceditcontainer.ej2Instances.ribbon.enableItems('custom_item', false);

Add Item

You can use the addItem API in the Document Editor ribbon to add a new item. Additionally, you can specify the target tab and group where the new item should be placed.

<template>
<div class="control-section">
    <ejs-documenteditorcontainer ref="doceditcontainer" :toolbarMode="'Ribbon'" 
    :serviceUrl="hostUrl" :enableToolbar='true' height='600px'></ejs-documenteditorcontainer>
</div>
</template>
<script setup>
import { DocumentEditorContainerComponent, Toolbar, Ribbon } from "@syncfusion/ej2-vue-documenteditor";
import { onMounted, ref } from 'vue';

const documenteditorcontainer = ref(null);
provide('DocumentEditorContainer', [Toolbar, Ribbon]);

onMounted(() => {
    const container = doceditcontainer.value?.ej2Instances;
    // To add the item at the end of the specified group (the item will be added at the end of the Undo group)
    const ribbonItem = {
      type: 'Button',
      buttonSettings: {
        content: 'New',
        iconCss: 'e-icons e-de-ctnr-new',
        clicked: () => {
          container.documentEditor.openBlank();
        }
      }
    };
    container.ribbon.addItem({ tabId: 'Home', index: 0 }, ribbonItem);

    // To add the item before the specified item index (the item will be added before the Redo item in the Undo group)

    container.ribbon.addItem({ tabId: 'Home', index: 0 }, ribbonItem, 1);
});
</script>
<template>
<div class="control-section">
    <ejs-documenteditorcontainer ref="doceditcontainer" :toolbarMode="'Ribbon'" 
    :serviceUrl="hostUrl" :enableToolbar='true' height='600px'></ejs-documenteditorcontainer>
</div>
</template>

<script>
import { DocumentEditorContainerComponent, Toolbar, Ribbon } from "@syncfusion/ej2-vue-documenteditor";

export default {
  components: {
    'ejs-documenteditorcontainer': DocumentEditorContainerComponent,
  },
  provide: {
    DocumentEditorContainer: [Toolbar, Ribbon]
  },
  mounted() {
    const container = this.$refs.doceditcontainer.ej2Instances;
    // To add the item at the end of the specified group (the item will be added at the end of the Undo group)
    const ribbonItem = {
      type: 'Button',
      buttonSettings: {
        content: 'New',
        iconCss: 'e-icons e-de-ctnr-new',
        clicked: () => {
          container.documentEditor.openBlank();
        }
      }
    };
    container.ribbon.addItem({ tabId: 'Home', index: 0 }, ribbonItem);

    // To add the item before the specified item index (the item will be added before the Redo item in the Undo group)

    container.ribbon.addItem({ tabId: 'Home', index: 0 }, ribbonItem, 1);
  }
};
</script>

Online Demo

Explore how to customize the ribbon in the Vue Document Editor for working with Word documents in this live demo here.

Customize Ribbon in Angular Document Document Editor

24 Jun 202620 minutes to read

The Angular DOCX Editor (Document Editor) provides an extensive and flexible API to customize the built-in ribbon UI. You can:

  • Customize the File menu.
  • Add the Backstage menu instead of File menu.
  • Show, hide, or add Ribbon tabs.
  • Show, hide, or add groups within tabs.
  • Show, hide, add, enable, or disable items within groups.

Below are detailed examples for each ribbon customization scenario.

File Menu Customization

Document Editor provides APIs to remove existing File menu items and add new custom items based on your requirements. You can modify the File menu using the fileMenuItems property.

In the example below, the “Open” and “Export” items have been removed from the File Menu Items, and new custom items have been added.

/**
 * Add below codes in app.component.html file
 */
<ejs-documenteditorcontainer #documenteditor_default [enableToolbar]=true [locale]="culture" [toolbarMode]="'Ribbon'" (created)="onCreate()" (documentChange)="onDocumentChange()" height="600px" [serviceUrl]="hostUrl" style="display:block;" [fileMenuItems]="fileMenuItems" (fileMenuItemClick)="fileMenuItemClick($event)"></ejs-documenteditorcontainer>

/**
 * Add below codes in app.component.ts file
 */
import { Component, ViewChild, ViewEncapsulation } from '@angular/core';
import { ToolbarService, DocumentEditorContainerComponent, RibbonService, DocumentEditorContainerModule } from '@syncfusion/ej2-angular-documenteditor';
import { SwitchModule } from '@syncfusion/ej2-angular-buttons';

@Component({
    selector: 'app-root',
    templateUrl: 'app.component.html',
    encapsulation: ViewEncapsulation.None,
    providers: [ToolbarService, RibbonService],
    standalone: true,
    imports: [DocumentEditorContainerModule, SwitchModule]
})
export class AppComponent {
    public hostUrl: string = 'https://document.syncfusion.com/web-services/docx-editor/api/documenteditor/';
    public toolbarMode: string = 'Ribbon';

    @ViewChild('documenteditor_default')
    public container!: DocumentEditorContainerComponent;

    public fileMenuItems: any = [
        "New",
        "Print",
        { text: 'Export', id: 'custom_item', iconCss: 'e-icons e-export' }
    ];

    public fileMenuItemClick(args: any): void {
        if (args.item.id) {
            this.container.documentEditor.save('Sample', 'Docx');
        }
    }
}

Backstage Menu Customization

The Document Editor provides an backStageMenu API to add a backstage menu. When the backstage menu is enabled, the default File menu items are automatically hidden.

The following code example shows how to add the backstage menu items.

/**
 * Add below codes in app.component.html file
 */
<ejs-documenteditorcontainer #documenteditor_default [enableToolbar]=true [locale]="culture" [toolbarMode]="'Ribbon'" (created)="onCreate()" (documentChange)="onDocumentChange()" height="600px" [serviceUrl]="hostUrl" style="display:block;" [backstageMenu]="backstageMenu"></ejs-documenteditorcontainer>

/**
 * Add below codes in app.component.ts file
 */
import { Component, ViewChild, ViewEncapsulation } from '@angular/core';
import { ToolbarService, DocumentEditorContainerComponent, RibbonService, DocumentEditorContainerModule } from '@syncfusion/ej2-angular-documenteditor';
import { SwitchModule } from '@syncfusion/ej2-angular-buttons';

@Component({
    selector: 'app-root',
    templateUrl: './app.component.html',
    encapsulation: ViewEncapsulation.None,
    providers: [ToolbarService, RibbonService],
    standalone: true,
    imports: [DocumentEditorContainerModule, SwitchModule]
})
export class AppComponent {
    public hostUrl: string = 'https://document.syncfusion.com/web-services/docx-editor/api/documenteditor/';

    @ViewChild('documenteditor_default', { static: true })
    public container!: DocumentEditorContainerComponent;

    public backstageMenu = {
        text: 'File',
        backButton: { text: 'close' },
        items: [
            { id: 'new', text: 'New', iconCss: 'e-icons e-de-ctnr-new' }
        ]
    };
}

Refer this documentation know more about backstage items

Tab Customization

You can customize the ribbon tabs in the Document Editor by showing, hiding, or adding tabs according to your application’s requirements.

Show/Hide Tab

Document editor provides the showTab API to show and hide the existing tab using existing RibbonTabType and tabId.

The following code example how to show/hide existing tab using existing tab type and tab id.

// To hide the Home tab using the built-in `RibbonTabType`
this.container.ribbon.showTab('Home', false);

// To hide a tab by its tab id (for example, a custom tab)
this.container.ribbon.showTab('custom_tab', false);

Add Tab

The Document Editor provides the addTab API, which allows you to insert a new custom tab either between existing tabs or at the end of the ribbon tabs.

import { Component, ViewChild, ViewEncapsulation, AfterViewInit } from '@angular/core';
import { ToolbarService, DocumentEditorContainerComponent, RibbonService, DocumentEditorContainerModule } from '@syncfusion/ej2-angular-documenteditor';
import { SwitchModule } from '@syncfusion/ej2-angular-buttons';

@Component({
    selector: 'app-root',
    templateUrl: './app.component.html',
    encapsulation: ViewEncapsulation.None,
    providers: [ToolbarService, RibbonService],
    standalone: true,
    imports: [DocumentEditorContainerModule, SwitchModule]
})
export class AppComponent implements AfterViewInit {
    public hostUrl: string = 'https://document.syncfusion.com/web-services/docx-editor/api/documenteditor/';

    @ViewChild('documenteditor_default', { static: true })
    public container!: DocumentEditorContainerComponent;

    ngAfterViewInit(): void {
        setTimeout(() => {

            // To add the tab at end of tab
            const ribbonTab = {
                header: 'Custom Tab',
                id: 'custom_tab',
                groups: [
                    {
                        header: 'Custom Group',
                        collections: [
                            {
                                items: [
                                    {
                                        type: 'Button',
                                        buttonSettings: {
                                            content: 'New',
                                            iconCss: 'e-icons e-de-ctnr-new',
                                            clicked: () => {
                                                this.container.documentEditor.openBlank();
                                            }
                                        }
                                    }
                                ]
                            }
                        ]
                    }
                ]
            };
            this.container.ribbon.addTab(ribbonTab);

            // To add the tab before the Insert tab(exising tab)

            this.container.ribbon?.addTab(ribbonTab, 'Insert');
        })
    }
}

Group Customization

You can also customize ribbon groups within a tab to better organize commands or add new functionalities as per your needs.

Show/Hide Group

Document Editor provides an showGroup API to show or hide existing groups within a ribbon tab.

The following code example show how to show/hide the group using group Id or RibbonGroupInfo.

// To hide the clipboard group using group index
this.container.ribbon.showGroup({tabId: 'Home', index: 1} , false);

// To show the clipboard group using group index
this.container.ribbon.showGroup({tabId: 'Home', index: 1} , true);

// To hide the group using id
this.container.ribbon.showGroup('custom_group', false);

Add Group

To extend the ribbon’s functionality, you can add custom groups to any tab. This allows you to organize related commands together within a tab.

import { Component, ViewChild, ViewEncapsulation, AfterViewInit } from '@angular/core';
import { ToolbarService, DocumentEditorContainerComponent, RibbonService, DocumentEditorContainerModule } from '@syncfusion/ej2-angular-documenteditor';
import { SwitchModule } from '@syncfusion/ej2-angular-buttons';

@Component({
    selector: 'app-root',
    templateUrl: './app.component.html',
    encapsulation: ViewEncapsulation.None,
    providers: [ToolbarService, RibbonService],
    standalone: true,
    imports: [DocumentEditorContainerModule, SwitchModule]
})
export class AppComponent implements AfterViewInit {
    public hostUrl: string = 'https://document.syncfusion.com/web-services/docx-editor/api/documenteditor/';

    @ViewChild('documenteditor_default', { static: true })
    public container!: DocumentEditorContainerComponent;

    ngAfterViewInit(): void {
        setTimeout(() => {

            // Add the new group at the end of the Home tab
            const ribbonGroup = {
                header: 'Custom Group',
                collections: [
                    {
                        items: [
                            {
                                type: 'Button',
                                buttonSettings: {
                                    content: 'New',
                                    iconCss: 'e-icons e-de-ctnr-new',
                                    clicked: () => {
                                        this.container.documentEditor.openBlank();
                                    }
                                }
                            }
                        ]
                    }
                ]
            };
            this.container.ribbon?.addGroup('Home', ribbonGroup);

            // Add the new group at the specified index of the Home tab (before the Clipboard group)

            this.container.ribbon?.addGroup('Home', ribbonGroup, 1);
        });
    }
}

Item Customization

You can customize individual items within ribbon groups. This includes showing, hiding, enabling, disabling, or adding new items to any group within a ribbon tab.

Show/Hide Item

Using showItems API in Document editor ribbon to enable/disable the existing item. Here, you can specify the item Id or [RibbonItemInfo].

The following code example show how to show/hide the item using item Id or RibbonItemInfo.

// To hide the Bold and Italic items using ribbon item information
this.container.ribbon.showItems({ tabId: 'Home', groupIndex: 2, itemIndexes: [5, 6] } , false);

// To show the Bold and Italic items using ribbon item information
this.container.ribbon.showItems({ tabId: 'Home', groupIndex: 2, itemIndexes: [5, 6] } , true);

// To hide the item using item id
this.container.ribbon.showItems('custom_item', false);

Enable/Disable Item

Using enableItems API in Document editor ribbon to enable/disable the existing item.

// To disable the underline using ribbon item info
this.container.ribbon.enableItems({ tabId: 'Home', groupIndex: 2, itemIndexes: [7] },false);

// To enable the underline using ribbon item info
this.container.ribbon.enableItems({ tabId: 'Home', groupIndex: 2, itemIndexes: [7] },true);

// To disable the item using id
this.container.ribbon.enableItems('custom_item', false);

Add Item

You can use the addItem API in the Document Editor ribbon to add a new item. Additionally, you can specify the target tab and group where the new item should be placed.

import { Component, ViewChild, ViewEncapsulation, AfterViewInit } from '@angular/core';
import { ToolbarService, DocumentEditorContainerComponent, RibbonService, DocumentEditorContainerModule } from '@syncfusion/ej2-angular-documenteditor';
import { SwitchModule } from '@syncfusion/ej2-angular-buttons';

@Component({
    selector: 'app-root',
    templateUrl: './app.component.html',
    encapsulation: ViewEncapsulation.None,
    providers: [ToolbarService, RibbonService],
    standalone: true,
    imports: [DocumentEditorContainerModule, SwitchModule]
})
export class AppComponent implements AfterViewInit {
    public hostUrl: string = 'https://document.syncfusion.com/web-services/docx-editor/api/documenteditor/';

    @ViewChild('documenteditor_default', { static: true })
    public container!: DocumentEditorContainerComponent;

    ngAfterViewInit(): void {
        // To add the item at the end of the specified group (the item will be added at the end of the Undo group)
        setTimeout(() => {
            const ribbonItem = {
                type: 'Button',
                buttonSettings: {
                    content: 'New',
                    iconCss: 'e-icons e-de-ctnr-new',
                    clicked: () => {
                        this.container.documentEditor.openBlank();
                    }
                }
            };

            this.container.ribbon?.addItem({ tabId: 'Home', index: 0 }, ribbonItem);

            // To add the item before the specified item index (the item will be added before the Redo item in the Undo group)

            this.container.ribbon?.addItem({ tabId: 'Home', index: 0 }, ribbonItem, 1);
        });
    }
}

Online Demo

Explore how to customize and use the ribbon interface in the Angular Document Editor to work with Word documents in this live demo here.

Customize Ribbon in React Document editor component

1 Jul 202620 minutes to read

The React DOCX Editor (Document Editor) provides an extensive and flexible API to customize the built-in ribbon UI. You can:

  • Customize the File menu.
  • Add the Backstage menu instead of File menu.
  • Show, hide, or add Ribbon tabs.
  • Show, hide, or add groups within tabs.
  • Show, hide, add, enable, or disable items within groups.

Below are detailed examples for each ribbon customization scenario.

File Menu Customization

Document Editor provides APIs to remove existing File menu items and add new custom items based on your requirements. You can modify the File menu using the fileMenuItems property.

In the example below, the “Open” and “Export” items have been removed from the File Menu Items, and new custom items have been added.

import { createRoot } from 'react-dom/client';
import * as React from 'react';
import { DocumentEditorContainerComponent, Ribbon, Toolbar } from '@syncfusion/ej2-react-documenteditor';
DocumentEditorContainerComponent.Inject(Toolbar, Ribbon);
const Default = () => {
  let hostUrl = "https://document.syncfusion.com/web-services/docx-editor/api/documenteditor/";
  let container = React.useRef(null);
  const fileMenuItemClick = (args) => {
    if (args.item.id) {
      container.current.documentEditor.save('Sample', 'Docx');
    }
  };
  return (<div className="control-pane">
    <div className="control-section">
      <div id="documenteditor_container_body">
        <DocumentEditorContainerComponent
          id="container"
          ref={container}
          style=
          height={'590px'}
          toolbarMode={'Ribbon'}
          enableToolbar={true}
          serviceUrl={hostUrl}
          fileMenuItems={[
            "New",
            "Print",
            { text: 'Export', id: 'custom_item', iconCss: 'e-icons e-export' }
          ]}
          fileMenuItemClick={fileMenuItemClick}
        />
      </div>
    </div>
  </div>);
};
export default Default;

const root = createRoot(document.getElementById('sample'));
root.render(<Default />);

Backstage Menu Customization

The Document Editor provides an backStageMenu API to add a backstage menu. When the backstage menu is enabled, the default File menu items are automatically hidden.

The following code example shows how to add the backstage menu items.

import { createRoot } from 'react-dom/client';
import * as React from 'react';
import { DocumentEditorContainerComponent, Ribbon, Toolbar } from '@syncfusion/ej2-react-documenteditor';
DocumentEditorContainerComponent.Inject(Toolbar, Ribbon);
const Default = () => {
    let hostUrl = "https://document.syncfusion.com/web-services/docx-editor/api/documenteditor/";
    let container = React.useRef(null);
    return (
        <div className="control-pane">
            <div className="control-section">
                <div id="documenteditor_container_body">
                    <DocumentEditorContainerComponent
                        id="container"
                        ref={container}
                        style={{ display: 'block' }}
                        height={'590px'}
                        toolbarMode="Ribbon"
                        enableToolbar={true}
                        backstageMenu={{
                            text: 'File',
                            backButton: { text: 'Close' },
                            items: [
                                { id: 'new', text: 'New', iconCss: 'e-icons e-de-ctnr-new' }
                            ]
                        }}
                    />
                </div>
            </div>
        </div>
    );
};
export default Default;

const root = createRoot(document.getElementById('sample'));
root.render(<Default />);

Refer this documentation know more about backstage items

Tab Customization

You can customize the ribbon tabs in the Document Editor by showing, hiding, or adding tabs according to your application’s requirements.

Show/Hide Tab

Document editor provides the showTab API to show and hide the existing tab using existing RibbonTabType and tabId.

The following code example how to show/hide existing tab using existing tab type and tab id.

// To hide the Home tab using the built-in `RibbonTabType`
container.current.ribbon.showTab('Home', false);

// To hide a tab by its tab id (for example, a custom tab)
container.current.ribbon.showTab('custom_tab', false);

Add Tab

The Document Editor provides the addTab API, which allows you to insert a new custom tab either between existing tabs or at the end of the ribbon tabs.

import { createRoot } from 'react-dom/client';
import * as React from 'react';
import { DocumentEditorContainerComponent, Ribbon, Toolbar } from '@syncfusion/ej2-react-documenteditor';
DocumentEditorContainerComponent.Inject(Toolbar, Ribbon);
const Default = () => {
  const hostUrl = 'https://document.syncfusion.com/web-services/docx-editor/api/documenteditor/';
  const container = React.useRef(null);

  // To add the tab at end of tab
  React.useEffect(() => {
      const ribbonTab = {
        header: 'Custom Tab',
        id: 'custom_tab',
        groups: [
          {
            header: 'Custom Group',
            collections: [
              {
                items: [
                  {
                    type: 'Button',
                    buttonSettings: {
                      content: 'New',
                      iconCss: 'e-icons e-de-ctnr-new',
                      clicked: () => {
                        container.current.documentEditor.openBlank();
                      }
                    }
                  }
                ]
              }
            ]
          }
        ]
      };
      container.current.ribbon.addTab(ribbonTab);

      // To add the tab before the Insert tab(exising tab)
      container.current.ribbon.addTab(ribbonTab, 'Insert');
  }, []);

  return (
    <div className="control-pane">
      <div className="control-section">
        <div id="documenteditor_container_body">
          <DocumentEditorContainerComponent
            id="container"
            ref={container}
            style=
            height={'590px'}
            toolbarMode={'Ribbon'}
            enableToolbar={true}
            serviceUrl={hostUrl}
          />
        </div>
      </div>
    </div>
  );
};
export default Default;

const root = createRoot(document.getElementById('sample'));
root.render(<Default />);

Group Customization

You can also customize ribbon groups within a tab to better organize commands or add new functionalities as per your needs.

Show/Hide Group

Document Editor provides an showGroup API to show or hide existing groups within a ribbon tab.

The following code example show how to show/hide the group using group Id or RibbonGroupInfo.

// To hide the clipboard group using group index
container.current.ribbon.showGroup({tabId: 'Home', index: 1} , false);

// To show the clipboard group using group index
container.current.ribbon.showGroup({tabId: 'Home', index: 1} , true);

// To hide the group using id
container.current.ribbon.showGroup('custom_group', false);

Add Group

To extend the ribbon’s functionality, you can add custom groups to any tab. This allows you to organize related commands together within a tab.

import { createRoot } from 'react-dom/client';
import * as React from 'react';
import { DocumentEditorContainerComponent, Ribbon, Toolbar } from '@syncfusion/ej2-react-documenteditor';
DocumentEditorContainerComponent.Inject(Toolbar, Ribbon);

const Default = () => {
  const hostUrl = 'https://document.syncfusion.com/web-services/docx-editor/api/documenteditor/';
  const container = React.useRef(null);

  // Add the new group at the end of the Home tab
  React.useEffect(() => {
      const ribbonGroup = {
        header: 'Custom Group',
        collections: [
          {
            items: [
              {
                type: 'Button',
                buttonSettings: {
                  content: 'New',
                  iconCss: 'e-icons e-de-ctnr-new',
                  clicked: () => {
                    container.current.documentEditor.openBlank();
                  }
                }
              }
            ]
          }
        ]
      };
      container.current.ribbon.addGroup('Home', ribbonGroup);

      // Add the new group at the specified index of the Home tab (before the Clipboard group)
      
      container.current.ribbon.addGroup('Home', ribbonGroup, 1);
  }, []);

  return (
    <div className="control-pane">
      <div className="control-section">
        <div id="documenteditor_container_body">
          <DocumentEditorContainerComponent
            id="container"
            ref={container}
            style=
            height="590px"
            toolbarMode="Ribbon"
            enableToolbar={true}
            serviceUrl={hostUrl}
          />
        </div>
      </div>
    </div>
  );
};
export default Default;

const root = createRoot(document.getElementById('sample'));
root.render(<Default />);

Item Customization

You can customize individual items within ribbon groups. This includes showing, hiding, enabling, disabling, or adding new items to any group within a ribbon tab.

Show/Hide Item

Using showItems API in Document editor ribbon to enable/disable the existing item. Here, you can specify the item Id or [RibbonItemInfo].

The following code example show how to show/hide the item using item Id or RibbonItemInfo.

// To hide the Bold and Italic items using ribbon item information
container.current.ribbon.showItems({ tabId: 'Home', groupIndex: 2, itemIndexes: [5, 6] } , false);

// To show the Bold and Italic items using ribbon item information
container.current.ribbon.showItems({ tabId: 'Home', groupIndex: 2, itemIndexes: [5, 6] } , true);

// To hide the item using item id
container.current.ribbon.showItems('custom_item', false);

Enable/Disable Item

Using enableItems API in Document editor ribbon to enable/disable the existing item.

// To disable the underline using ribbon item info
container.current.ribbon.enableItems({ tabId: 'Home', groupIndex: 2, itemIndexes: [7] },false);

// To enable the underline using ribbon item info
container.current.ribbon.enableItems({ tabId: 'Home', groupIndex: 2, itemIndexes: [7] },true);

// To disable the item using id
container.current.ribbon.enableItems('custom_item', false);

Add Item

You can use the addItem API in the Document Editor ribbon to add a new item. Additionally, you can specify the target tab and group where the new item should be placed.

import { createRoot } from 'react-dom/client';
import * as React from 'react';
import {
  DocumentEditorContainerComponent,
  Toolbar,
  Ribbon
} from '@syncfusion/ej2-react-documenteditor';
DocumentEditorContainerComponent.Inject(Toolbar, Ribbon);

const Default = () => {
  const hostUrl = 'https://document.syncfusion.com/web-services/docx-editor/api/documenteditor/';
  const container = React.useRef(null);
  
  // To add the item at the end of the specified group (the item will be added at the end of the Undo group)
  React.useEffect(() => {
      const ribbonItem = {
        type: 'Button',
        buttonSettings: {
          content: 'New',
          iconCss: 'e-icons e-de-ctnr-new',
          clicked: () => {
            container.current.documentEditor.openBlank();
          }
        }
      };
      container.current.ribbon.addItem({ tabId: 'Home', index: 0 }, ribbonItem);
      
      // To add the item before the specified item index (the item will be added before the Redo item in the Undo group)

      container.current.ribbon.addItem({ tabId: 'Home', index: 0 }, ribbonItem, 1);
  }, []);

  return (
    <div className="control-pane">
      <div className="control-section">
        <div id="documenteditor_container_body">
          <DocumentEditorContainerComponent
            id="container"
            ref={container}
            style=
            height="590px"
            toolbarMode="Ribbon"
            enableToolbar={true}
            serviceUrl={hostUrl}
          />
        </div>
      </div>
    </div>
  );
};
export default Default;

const root = createRoot(document.getElementById('sample'));
root.render(<Default />);

Online Demo

Explore how to customize the ribbon in the React Document Editor for working with Word documents in this live demo here.